diff --git a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
index 218fccdc7..1ba52c28e 100644
--- a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.net.handler;
 
-import net.minecraft.client.gui.GuiSelectServer;
+import net.minecraft.client.gui.SelectServerScreen;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.ServerAddress;
 import net.minecraft.core.net.ServerData;
@@ -16,14 +16,14 @@ public class PingPacketHandler
     extends PacketHandler
 {
     private boolean disconnected = false;
-    private final GuiSelectServer gui;
+    private final SelectServerScreen screen;
     private final NetworkManager netManager;
     private final ServerData server;
     public static long startTime = 0;
 
-    public PingPacketHandler(GuiSelectServer gui, ServerData server)
+    public PingPacketHandler(SelectServerScreen screen, ServerData server)
         throws IOException {
-        this.gui = gui;
+        this.screen = screen;
         this.server = server;
         ServerAddress address = server.getServerAddress();
         Socket socket = new Socket(InetAddress.getByName(address.getIP()), address.getPort());
@@ -64,7 +64,7 @@ public class PingPacketHandler
             server.maxPlayers = parseIntWithDefault(serverInfo[5], -1);
             server.latency = System.currentTimeMillis() - startTime;
 
-            gui.handleIncomingServerInfo(server);
+            screen.handleIncomingServerInfo(server);
 
             netManager.networkShutdown("disconnect.kicked", new Object[0]);
             disconnected = true;
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java
index 8a46b17cb..51546d8f0 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java
+++ b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.net.thread;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.texture.DownloadedTexture;
 import net.minecraft.client.render.ImageParser;
+import org.slf4j.Logger;
 
 import java.awt.image.BufferedImage;
 import java.io.InputStream;
@@ -11,7 +13,7 @@ import java.net.URL;
 import javax.imageio.ImageIO;
 
 public class ThreadDownloadImage extends Thread {
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private static int counter = 0;
 	
 	public final String url;
@@ -49,7 +51,7 @@ public class ThreadDownloadImage extends Thread {
 
 			inputStream.close();
 		} catch (Exception exception) {
-			exception.printStackTrace();
+            LOGGER.error("Exception when getting image from '{}'!", url, exception);
 		} finally {
 			if(connection != null) connection.disconnect();
 		}
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
index 8619de121..fd6f4601d 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
+++ b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
@@ -6,7 +6,6 @@ import static com.b100.utils.StreamUtils.*;
 import java.io.BufferedInputStream;
 import java.io.BufferedOutputStream;
 import java.io.File;
-import java.io.FileOutputStream;
 import java.net.URL;
 import java.nio.file.Files;
 import java.util.ArrayList;
@@ -20,10 +19,13 @@ import com.b100.xml.XmlFile;
 import com.b100.xml.XmlParser;
 import com.b100.xml.element.XmlContentTag;
 import com.b100.xml.element.XmlTag;
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import org.slf4j.Logger;
 
 public class ThreadDownloadResources extends Thread {
 
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static String[] extractFiles = new String[]{"ui/ui_back.ogg", "ui/ui_click.ogg", "ui/ui_focus.ogg", "ui/ui_scroll.ogg", "ui/crafting_fail.ogg", "ui/crafting_made.ogg"};
     public static String resourceDomain = "https://api.betterthanadventure.net/MinecraftResources/";
 
@@ -56,26 +58,24 @@ public class ThreadDownloadResources extends Thread {
             }
 
         } catch (Exception e) {
-            e.printStackTrace();
+            LOGGER.error("Exception when copying 'sound/ui/' files to resources!", e);
         }
 
         try {
             if (mc.gameSettings.downloadSoundfiles.value) {
-                System.out.println("Downloading sounds...");
+                LOGGER.info("Downloading sounds...");
                 try {
                     downloadResources();
                 } catch (Exception e) {
                     downloading = false;
-                    System.err.println("Error downloading sounds...");
-                    e.printStackTrace();
+                    LOGGER.error("Error downloading sounds...", e);
                 }
             }
         } catch (Exception e) {
-            e.printStackTrace();
+            LOGGER.error("Error downloading sounds", e);
         }
     }
 
-
     public void downloadResources() {
         String xmlString = StringUtils.getWebsiteContentAsString(resourceDomain);
 
@@ -148,15 +148,15 @@ public class ThreadDownloadResources extends Thread {
         String url = resourceDomain + name;
         url = url.replace(" ", "%20");
 
-        System.out.println("Downloading File: " + url);
+        LOGGER.info("Downloading File: {}", url);
 
         transferDataAndClose(new BufferedInputStream(new URL(url).openStream()), new BufferedOutputStream(Files.newOutputStream(createNewFile(file).toPath())));
     }
 
     private static class SoundEntry {
-        private File file;
-        private String name;
-        private long size;
+        private final File file;
+        private final String name;
+        private final long size;
 
         public SoundEntry(File file, String name, long size) {
             this.file = file;
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java b/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
index ec1702841..7f28e0a8b 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
+++ b/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.net.thread;
 
-import net.minecraft.client.gui.GuiSelectServer;
+import net.minecraft.client.gui.SelectServerScreen;
 import net.minecraft.client.net.handler.PingPacketHandler;
 import net.minecraft.core.Global;
 import net.minecraft.core.net.ServerAddress;
@@ -11,13 +11,13 @@ import net.minecraft.core.net.packet.PingHandshakePacket;
 public class ThreadPingServer
     extends Thread {
 
-    private final GuiSelectServer gui;
+    private final SelectServerScreen screen;
     private final ServerData server;
     private boolean done = false;
     private PingPacketHandler netHandler = null;
 
-    public ThreadPingServer(GuiSelectServer gui, ServerData server) {
-        this.gui = gui;
+    public ThreadPingServer(SelectServerScreen screen, ServerData server) {
+        this.screen = screen;
         this.server = server;
         ServerAddress address = server.getServerAddress();
         this.setName("ThreadPingServer - " + address.getIP() + ":" + address.getPort());
@@ -46,7 +46,7 @@ public class ThreadPingServer
         int port = address.getPort();
 
         try {
-            netHandler = new PingPacketHandler(gui, server);
+            netHandler = new PingPacketHandler(screen, server);
             netHandler.addToSendQueue(new PingHandshakePacket(0x01, 0xFA, "BTAPingHost", Global.MP_PROTOCOL_VERSION, hostName, port));
         } catch (Exception ignored) {
         } finally {
diff --git a/src/main/java/net/minecraft/client/option/ColorOption.java b/src/main/java/net/minecraft/client/option/ColorOption.java
index dd4ea3d43..82c686dff 100644
--- a/src/main/java/net/minecraft/client/option/ColorOption.java
+++ b/src/main/java/net/minecraft/client/option/ColorOption.java
@@ -1,9 +1,11 @@
 package net.minecraft.client.option;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.util.helper.Color;
+import org.slf4j.Logger;
 
 public class ColorOption extends Option<Color>{
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public ColorOption(GameSettings gameSettings, String name, Color defaultValue) {
 		super(gameSettings, name, defaultValue);
 	}
@@ -13,7 +15,7 @@ public class ColorOption extends Option<Color>{
 		try{
 			this.value.parse(string);
 		}catch (Exception e) {
-			e.printStackTrace();
+            LOGGER.error("Failed to parse color for '{}'!", string, e);
 		}
 	}
 	
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index f1f8fafe9..8449cfe20 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -10,15 +10,16 @@ import java.io.PrintWriter;
 import java.util.ArrayList;
 import java.util.List;
 
+import com.mojang.logging.LogUtils;
+
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
-import net.minecraft.client.gui.hud.HudComponents;
+import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.enums.Colorblindness;
 import net.minecraft.client.option.enums.Difficulty;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.option.enums.MipmapType;
-import net.minecraft.client.option.enums.RenderDistance;
 import net.minecraft.client.option.enums.RenderScale;
 import net.minecraft.client.option.enums.TooltipStyle;
 import net.minecraft.core.enums.PlacementMode;
@@ -26,13 +27,14 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.ITranslatable;
+import org.slf4j.Logger;
 
 public class GameSettings {
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private static final String[] ANIMATIONS = { "options.animations.off", "options.animations.procedural", "options.animations.custom" };
 
 	public final Minecraft mc;
-	private File optionsFile;
+	private final File optionsFile;
 
 	public IntegerOption windowWidth = new IntegerOption(this, "windowWidth", 854);
 	public IntegerOption windowHeight = new IntegerOption(this, "windowHeight", 480);
@@ -163,6 +165,7 @@ public class GameSettings {
 	public BooleanOption aurora = new BooleanOption(this, "aurora", true);
 	public BooleanOption mobVariants = new BooleanOption(this, "mobVariants", true);
 	public EnumOption<Colorblindness> colorblindnessFix = new EnumOption<>(this, "colorblindnessFix", Colorblindness.class, Colorblindness.NONE);
+	public BooleanOption subtitles = new BooleanOption(this, "subtitles", false);
 
 	public KeyBinding keyAttack = new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0);
 	public KeyBinding keyInteract = new KeyBinding("key.interact").setDefault(InputDevice.mouse, 1);
@@ -406,6 +409,7 @@ public class GameSettings {
 	}
 
 	public void optionChanged(Option<?> option) {
+		if (option == null) return;
 		if (option == difficulty) {
 			if (mc.theWorld != null) {
 				mc.theWorld.setDifficulty(difficulty.value, false);
@@ -417,13 +421,13 @@ public class GameSettings {
 		if(option == advancedOpenGL) mc.renderGlobal.loadRenderers();
 		if(option == biomeWater) {
 			mc.renderGlobal.loadRenderers();
-			mc.renderEngine.updateDynamicTextures(false);
+			mc.textureManager.updateDynamicTextures(false);
 		}
 		if(option == treeShadows) mc.renderGlobal.loadRenderers();
 		if(option == placementMode && mc.thePlayer != null) mc.thePlayer.syncPlacementMode();
 		if(option == animations || option == customAnimations) {
-			mc.renderEngine.refreshTexturesAndDisplayErrors();
-			mc.renderEngine.updateDynamicTextures(false);
+			mc.textureManager.refreshTexturesAndDisplayErrors();
+			mc.textureManager.updateDynamicTextures(false);
 		}
 		if(option == fullscreen) mc.gameWindow.updateWindowState();
 		if(option == borderlessFullscreen && fullscreen.value) mc.gameWindow.updateWindowState();
@@ -432,11 +436,11 @@ public class GameSettings {
 			guiScale.value = (guiScale.value + max) % max;
 			mc.resolution.update();
 			if (mc.currentScreen != null) {
-				mc.currentScreen.setWorldAndResolution(mc, mc.resolution.scaledWidth, mc.resolution.scaledHeight);
+				mc.currentScreen.init(mc, mc.resolution.scaledWidth, mc.resolution.scaledHeight);
 			}
 		}
 		if(option == mipmapType || option == mipmapLevels) {
-			mc.renderEngine.refreshTexturesAndDisplayErrors();
+			mc.textureManager.refreshTexturesAndDisplayErrors();
 		}
 		if(option == autosaveTimer) {
 			int max = 24;
@@ -452,7 +456,7 @@ public class GameSettings {
 		}
 		if(option == language) {
 			if (mc.currentScreen != null) {
-				mc.currentScreen.setWorldAndResolution(mc, mc.resolution.scaledWidth, mc.resolution.scaledHeight);
+				mc.currentScreen.init(mc, mc.resolution.scaledWidth, mc.resolution.scaledHeight);
 			}
 		}
 		if(option == lightmapStyle) {
@@ -499,14 +503,13 @@ line:		for (String line = ""; (line = br.readLine()) != null;) {
                         }
                     }
 				} catch (Exception e) {
-					System.out.println("Skipping bad option: "+line);
+                    LOGGER.warn("Skipping bad option: {}", line, e);
 				}
 			}
 
 			br.close();
 		} catch (Exception e) {
-			System.out.println("Failed to load options");
-			e.printStackTrace();
+			LOGGER.error("Failed to load options", e);
 		}
 	}
 	
@@ -529,8 +532,7 @@ line:		for (String line = ""; (line = br.readLine()) != null;) {
 
 			printwriter.close();
 		} catch (Exception exception) {
-			System.out.println("Failed to save options");
-			exception.printStackTrace();
+			LOGGER.error("Failed to save options", exception);
 		}
 	}
 
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 80d9856b1..19be7b340 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -101,7 +101,7 @@ public abstract class PlayerController {
 					setMineBlock(x, y, z);
 				}
 				
-				mc.effectRenderer.addBlockHitEffects(x, y, z, side);
+				mc.particleEngine.crack(x, y, z, side);
 				playDigSound(mineBlock, x, y, z);
 				 
 				currentDamage += mineStrength;
@@ -200,11 +200,11 @@ public abstract class PlayerController {
 
 	public void render(float f) {
 		if (currentDamage <= 0.0F) {
-			mc.ingameGUI.damageGuiPartialTime = 0.0F;
+			mc.ingameHud.damageGuiPartialTime = 0.0F;
 			mc.renderGlobal.damagePartialTime = 0.0F;
 		} else {
 			float f1 = previousDamage + (currentDamage - previousDamage) * f;
-			mc.ingameGUI.damageGuiPartialTime = f1;
+			mc.ingameHud.damageGuiPartialTime = f1;
 			mc.renderGlobal.damagePartialTime = f1;
 		}
 	}
diff --git a/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
index a9785542e..37963ef6e 100644
--- a/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
@@ -60,15 +60,15 @@ public class BlockEntityRenderDispatcher
         return getRenderer(tileEntity) != null;
     }
 
-    public void cacheActiveRenderInfo(World world, RenderEngine renderEngine, FontRenderer fontRenderer, ICamera camera, float partialTick)
+    public void cacheActiveRenderInfo(World world, TextureManager textureManager, Font font, ICamera camera, float partialTick)
     {
         if(worldObj != world)
         {
             updateRendererWorldCache(world);
         }
-        this.renderEngine = renderEngine;
+        this.textureManager = textureManager;
         this.camera = camera;
-        this.fontRenderer = fontRenderer;
+        this.font = font;
         viewLerpYaw = (float) camera.getYRot(partialTick);
         viewLerpPitch = (float) camera.getXRot(partialTick);
         viewLerpPosX = (float) camera.getX(partialTick);
@@ -118,18 +118,18 @@ public class BlockEntityRenderDispatcher
         }
     }
 
-    public FontRenderer getFontRenderer()
+    public Font getFont()
     {
-        return fontRenderer;
+        return font;
     }
 
     private final Map<Class<?>, BlockEntityRenderer<?>> renderers;
     public static BlockEntityRenderDispatcher instance = new BlockEntityRenderDispatcher();
-    private FontRenderer fontRenderer;
+    private Font font;
     public static double renderPosX;
     public static double renderPosY;
     public static double renderPosZ;
-    public RenderEngine renderEngine;
+    public TextureManager textureManager;
     public World worldObj;
     public ICamera camera;
     public float viewLerpYaw;
diff --git a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index 5867617a9..8483bf786 100644
--- a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -154,12 +154,12 @@ public class EntityRenderDispatcher
         return getRenderer(entity.getClass());
     }
 
-    public void cacheActiveRenderInfo(World world, RenderEngine renderEngine, FontRenderer fontRenderer, ICamera camera, GameSettings gameSettings, float partialTick)
+    public void cacheActiveRenderInfo(World world, TextureManager textureManager, Font font, ICamera camera, GameSettings gameSettings, float partialTick)
     {
         this.world = world;
-        this.renderEngine = renderEngine;
+        this.textureManager = textureManager;
         this.gameSettings = gameSettings;
-        this.fontRenderer = fontRenderer;
+        this.font = font;
         this.camera = camera;
         viewLerpYaw = (float) camera.getYRot(partialTick);
         viewLerpPitch = (float) camera.getXRot(partialTick);
@@ -233,18 +233,18 @@ public class EntityRenderDispatcher
         return dx * dx + dy * dy + dz * dz;
     }
 
-    public FontRenderer getFontRenderer()
+    public Font getFont()
     {
-        return fontRenderer;
+        return font;
     }
 
     private final Map<Class<?>, EntityRenderer<?>> renderers;
     public static EntityRenderDispatcher instance = new EntityRenderDispatcher();
-    private FontRenderer fontRenderer;
+    private Font font;
     public static double renderPosX;
     public static double renderPosY;
     public static double renderPosZ;
-    public RenderEngine renderEngine;
+    public TextureManager textureManager;
     public ItemRenderer itemRenderer;
     public World world;
     public ICamera camera;
diff --git a/src/main/java/net/minecraft/client/render/FlagRenderer.java b/src/main/java/net/minecraft/client/render/FlagRenderer.java
index c4b09a2c3..543598f30 100644
--- a/src/main/java/net/minecraft/client/render/FlagRenderer.java
+++ b/src/main/java/net/minecraft/client/render/FlagRenderer.java
@@ -11,15 +11,15 @@ public class FlagRenderer {
     public final int CANVAS_WIDTH = 24;
     public final int CANVAS_HEIGHT = 16;
 
-    private final RenderEngine renderEngine;
+    private final TextureManager textureManager;
     
     private final int texture;
     
-    public FlagRenderer(RenderEngine renderEngine)
+    public FlagRenderer(TextureManager textureManager)
     {
-        this.renderEngine = renderEngine;
+        this.textureManager = textureManager;
         
-        texture = renderEngine.createTexture(CANVAS_WIDTH, CANVAS_HEIGHT);
+        texture = textureManager.createTexture(CANVAS_WIDTH, CANVAS_HEIGHT);
     }
 
     @Override
@@ -32,7 +32,7 @@ public class FlagRenderer {
     {
         byte[] flagColors = tileEntity.flagColors;
         int[] rgbFlagColors = flagDataToRGB(tileEntity, flagColors);
-        renderEngine.updateTextureData(rgbFlagColors, CANVAS_WIDTH, CANVAS_HEIGHT, texture);
+        textureManager.updateTextureData(rgbFlagColors, CANVAS_WIDTH, CANVAS_HEIGHT, texture);
     }
     
     public int getTexture()
diff --git a/src/main/java/net/minecraft/client/render/FogManager.java b/src/main/java/net/minecraft/client/render/FogManager.java
index 13cfe5885..bf0d56965 100644
--- a/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/src/main/java/net/minecraft/client/render/FogManager.java
@@ -9,8 +9,8 @@ import org.lwjgl.opengl.NVFogDistance;
 
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiPhotoMode;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.PhotoModeScreen;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
 import net.minecraft.client.option.enums.RenderDistance;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.colorizer.Colorizers;
@@ -78,9 +78,9 @@ public class FogManager {
 
             if (fogDistance > maxFogDistance * fogModifier) fogDistance = maxFogDistance * fogModifier;
 
-            if (mc.currentScreen instanceof GuiPhotoMode)
+            if (mc.currentScreen instanceof PhotoModeScreen)
             {
-                fogDistance = farPlaneDistance * ((GuiPhotoMode)mc.currentScreen).getFog(partialTick);
+                fogDistance = farPlaneDistance * ((PhotoModeScreen)mc.currentScreen).getFog(partialTick);
             }
 
             glFogi(GL_FOG_MODE, GL_LINEAR);
@@ -170,8 +170,8 @@ public class FogManager {
         fogRed *= brightness;
         fogGreen *= brightness;
         fogBlue *= brightness;
-        if (mc.currentScreen instanceof GuiModelViewer) {
-            float[] color = ((GuiModelViewer) mc.currentScreen).getBackgroundFogColor();
+        if (mc.currentScreen instanceof ModelViewerScreen) {
+            float[] color = ((ModelViewerScreen) mc.currentScreen).getBackgroundFogColor();
             fogRed = color[0];
             fogGreen = color[1];
             fogBlue = color[2];
diff --git a/src/main/java/net/minecraft/client/render/FontRenderer.java b/src/main/java/net/minecraft/client/render/Font.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/FontRenderer.java
rename to src/main/java/net/minecraft/client/render/Font.java
index e1b89fbf9..9e8c28c82 100644
--- a/src/main/java/net/minecraft/client/render/FontRenderer.java
+++ b/src/main/java/net/minecraft/client/render/Font.java
@@ -21,7 +21,7 @@ import java.util.List;
 import java.util.Random;
 import java.util.regex.Pattern;
 
-public class FontRenderer {
+public class Font {
     private static final Pattern FORMATTING_CODE_REGEX = Pattern.compile("(?i)\\u00A7[0-9A-FK-OR]");
 
     private final GameSettings gameSettings;
@@ -35,7 +35,7 @@ public class FontRenderer {
     private final int[] glyphTextureNames;
     private final int[] colorCode;
     private int boundTextureName;
-    private final RenderEngine renderEngine;
+    private final TextureManager textureManager;
     private float posX;
     private float posY;
     private boolean bidiFlag;
@@ -50,7 +50,7 @@ public class FontRenderer {
     private boolean underlineStyle;
     private boolean strikethroughStyle;
 
-    public FontRenderer(Minecraft minecraft, GameSettings gameSettings, String fontPath, RenderEngine renderEngine) {
+    public Font(Minecraft minecraft, GameSettings gameSettings, TextureManager textureManager) {
         this.mc = minecraft;
         this.gameSettings = gameSettings;
         this.charWidth = new byte[65536];
@@ -66,7 +66,7 @@ public class FontRenderer {
         this.italicStyle = false;
         this.underlineStyle = false;
         this.strikethroughStyle = false;
-        this.renderEngine = renderEngine;
+        this.textureManager = textureManager;
 
         try (InputStream glyphStream = mc.texturePackList.getResourceAsStream("/font/glyph_sizes.bin");
              InputStream glyphStreamDefault = mc.texturePackList.getResourceAsStream("/font/glyph_sizes_default.bin")) {
@@ -120,9 +120,9 @@ public class FontRenderer {
         String fontPath = String.format("/font/font_%02X.png", id);
         String glyphPath = String.format("/font/glyph_%02X.png", id);
 
-        Texture fontTexture = this.renderEngine.loadTextureNoDefault(fontPath);
+        Texture fontTexture = this.textureManager.loadTextureNoDefault(fontPath);
         if (fontTexture == null) {
-            fontTexture = this.renderEngine.loadTextureNoDefault(glyphPath);
+            fontTexture = this.textureManager.loadTextureNoDefault(glyphPath);
         }
         if (fontTexture == null) {
             throw new RuntimeException("Failed to load texture from '" + fontPath + "' or '" + glyphPath + "'!");
@@ -187,7 +187,7 @@ public class FontRenderer {
             throw new RuntimeException(var5);
         }
 
-        this.glyphTextureNames[id] = this.renderEngine.loadBufferedTexture(glyphTexture).id();
+        this.glyphTextureNames[id] = this.textureManager.loadBufferedTexture(glyphTexture).id();
         this.boundTextureName = this.glyphTextureNames[id];
     }
 
diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 931d744ea..bd88d605e 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -101,7 +101,7 @@ public class ItemRenderer
             f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
             GL11.glRotatef(f18 * 70F, 0.0F, 1.0F, 0.0F);
             GL11.glRotatef(-f14 * 20F, 0.0F, 0.0F, 1.0F);
-            mc.renderEngine.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
+            mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
             GL11.glTranslatef(-1F, 3.6F, 3.5F);
             GL11.glRotatef(120F, 0.0F, 0.0F, 1.0F);
             GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
@@ -164,7 +164,7 @@ public class ItemRenderer
 
 		}
 		if(mc.thePlayer.isUnderLiquid(Material.water)) {
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/misc/water.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/misc/water.png").bind();
 			renderWarpedTextureOverlay(partialTicks);
 		}
 		glEnable(GL_ALPHA_TEST);
diff --git a/src/main/java/net/minecraft/client/render/LightmapHelper.java b/src/main/java/net/minecraft/client/render/LightmapHelper.java
index 17b446b2b..55fc7dcf6 100644
--- a/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -5,17 +5,21 @@ import static org.lwjgl.opengl.GL13.*;
 
 import java.awt.image.BufferedImage;
 import java.nio.ByteBuffer;
+import java.util.Arrays;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiPhotoMode;
+import net.minecraft.client.gui.PhotoModeScreen;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.util.helper.Buffer;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 public class LightmapHelper {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private static LightmapHelper instance = null;
 
 	public static boolean isLightmapEnabled() {
@@ -26,7 +30,7 @@ public class LightmapHelper {
 	public final WorldRenderer worldRenderer;
 
 	private int lightmapTexture = 0;
-	private int[] lightmapData = new int[256];
+	private final int[] lightmapData = new int[256];
 	public BufferedImage customLightmap;
 	
 	private float prevSkyDarken;
@@ -44,18 +48,18 @@ public class LightmapHelper {
 			int dimension = world.dimension.id;
 			
 			String path = "/assets/minecraft/textures/environment/lightmap" + dimension + ".png";
-			
-			System.out.println("Loading lightmap '" + path + "'");
-			customLightmap = mc.renderEngine.getImage(path);
+
+            LOGGER.info("Loading custom lightmap '{}'", path);
+			customLightmap = mc.textureManager.getImage(path);
 			
 			if(customLightmap == Textures.missingTexture) {
 				customLightmap = null;
 			}
 			
 			if(customLightmap != null) {
-				System.out.println("Loaded lightmap!");
+				LOGGER.info("Loaded custom lightmap!");
 			}else {
-				System.out.println("No lightmap!");
+				LOGGER.info("No custom lightmap found");
 			}
 		}else {
 			customLightmap = null;
@@ -91,9 +95,7 @@ public class LightmapHelper {
 		}
 
 		if(mc.fullbright) {
-			for(int i = 0; i < lightmapData.length; i++) {
-				lightmapData[i] = 0xFFFFFFFF;
-			}
+            Arrays.fill(lightmapData, 0xFFFFFFFF);
 		} else {
 			if(mc.gameSettings.customLightmap.value && customLightmap != null) {
 				generateCustomLightmap(world);
@@ -167,7 +169,7 @@ public class LightmapHelper {
 			
 			if(smooth) {
 				float skyDarken = prevSkyDarken + (skyDarkenSmooth - prevSkyDarken) * partialTicks;
-				if(mc.currentScreen instanceof GuiPhotoMode) {
+				if(mc.currentScreen instanceof PhotoModeScreen) {
 					skyDarken = world.skyDarken;
 				}
 				float modifiedSkylight = Math.max(0, skyLightLevel - skyDarken);
diff --git a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index 879719c49..88b56cca5 100644
--- a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -171,7 +171,7 @@ public class LoadingScreenRenderer
         GL11.glLoadIdentity();
         GL11.glTranslatef(0.0F, 0.0F, -200F);
         Tessellator t = Tessellator.instance;
-        minecraft.renderEngine.loadTexture(backgroundPath).bind();
+        minecraft.textureManager.loadTexture(backgroundPath).bind();
         float f = 32F;
 
         // Draw background
@@ -207,11 +207,11 @@ public class LoadingScreenRenderer
         }
 
         // Draw title and stage
-        minecraft.fontRenderer.drawStringWithShadow(title, (width - minecraft.fontRenderer.getStringWidth(title)) / 2, height / 2 - 4 - 16, 0xffffff);
-        minecraft.fontRenderer.drawStringWithShadow(stage, (width - minecraft.fontRenderer.getStringWidth(stage)) / 2, (height / 2 - 4) + 8, 0xffffff);
+        minecraft.font.drawStringWithShadow(title, (width - minecraft.font.getStringWidth(title)) / 2, height / 2 - 4 - 16, 0xffffff);
+        minecraft.font.drawStringWithShadow(stage, (width - minecraft.font.getStringWidth(stage)) / 2, (height / 2 - 4) + 8, 0xffffff);
 
         // Draw tip
-        minecraft.fontRenderer.drawStringWithShadow(tip, (width - minecraft.fontRenderer.getStringWidth(tip)) / 2, (height / 2 - 4) + 32, 0xffffff);
+        minecraft.font.drawStringWithShadow(tip, (width - minecraft.font.getStringWidth(tip)) / 2, (height / 2 - 4) + 32, 0xffffff);
         
         minecraft.renderer.endRenderGame(1.0f);
         
